<html>
<head>
<title>OgreHardwareBuffer.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreHardwareBuffer.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreHardwareBuffer_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __HardwareBuffer__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __HardwareBuffer__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="comment">// Precompiler options</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreException_8h.html">OgreException.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>Ogre {
<a name="l00036"></a>00036 
<a name="l00074"></a><a class="code" href="classOgre_1_1HardwareBuffer.html">00074</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1HardwareBuffer.html" title="Abstract class defining common features of hardware buffers.">HardwareBuffer</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">BufferAlloc</a>
<a name="l00075"></a>00075     {
<a name="l00076"></a>00076 
<a name="l00077"></a>00077         <span class="keyword">public</span>:
<a name="l00079"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#ae51f5970d879af736e4cf53e1ec46630">00079</a>             <span class="keyword">enum</span> <a class="code" href="classOgre_1_1HardwareBuffer.html#ae51f5970d879af736e4cf53e1ec46630" title="Enums describing buffer usage; not mutually exclusive.">Usage</a> 
<a name="l00080"></a>00080             {
<a name="l00084"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#ae51f5970d879af736e4cf53e1ec46630a6f26f67ab31d60248314c9c6c77c9edb">00084</a>                 HBU_STATIC = 1,
<a name="l00090"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#ae51f5970d879af736e4cf53e1ec46630abec61c14b13652a06566a79afd6f7518">00090</a>                 HBU_DYNAMIC = 2,
<a name="l00097"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#ae51f5970d879af736e4cf53e1ec46630a2fe20ff00e9acb928a2d9680f0c505e2">00097</a>                 HBU_WRITE_ONLY = 4,
<a name="l00106"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#ae51f5970d879af736e4cf53e1ec46630a246699879ba7647973a2d8ed86acf76f">00106</a>                 HBU_DISCARDABLE = 8,
<a name="l00108"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#ae51f5970d879af736e4cf53e1ec46630a5ffbb339becd31435c5f616be4c28996">00108</a>                 HBU_STATIC_WRITE_ONLY = 5, 
<a name="l00114"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#ae51f5970d879af736e4cf53e1ec46630aa0c82d1b27d6cc04e4b5f6d47a22a74c">00114</a>                 HBU_DYNAMIC_WRITE_ONLY = 6,
<a name="l00116"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#ae51f5970d879af736e4cf53e1ec46630a29ff2e0fd2b408359e84291b27282516">00116</a>                 HBU_DYNAMIC_WRITE_ONLY_DISCARDABLE = 14
<a name="l00117"></a>00117 
<a name="l00118"></a>00118 
<a name="l00119"></a>00119             };
<a name="l00121"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#aac34930556f611928ec9157c04bd1b0f">00121</a>             <span class="keyword">enum</span> <a class="code" href="classOgre_1_1HardwareBuffer.html#aac34930556f611928ec9157c04bd1b0f" title="Locking options.">LockOptions</a>
<a name="l00122"></a>00122             {
<a name="l00124"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#aac34930556f611928ec9157c04bd1b0fae11601d29cd56aad7ea7a1b23a688b0e">00124</a>                 <a class="code" href="classOgre_1_1HardwareBuffer.html#aac34930556f611928ec9157c04bd1b0fae11601d29cd56aad7ea7a1b23a688b0e" title="Normal mode, ie allows read/write and contents are preserved.">HBL_NORMAL</a>,
<a name="l00129"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#aac34930556f611928ec9157c04bd1b0fa176ad39ac15fc0a6028d820a6fe228ae">00129</a>                 <a class="code" href="classOgre_1_1HardwareBuffer.html#aac34930556f611928ec9157c04bd1b0fa176ad39ac15fc0a6028d820a6fe228ae" title="Discards the entire buffer while locking; this allows optimisation to be performed because synchronis...">HBL_DISCARD</a>,
<a name="l00133"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#aac34930556f611928ec9157c04bd1b0faa364c1511514cd4d7ee1e7092eb41288">00133</a>                 <a class="code" href="classOgre_1_1HardwareBuffer.html#aac34930556f611928ec9157c04bd1b0faa364c1511514cd4d7ee1e7092eb41288" title="Lock the buffer for reading only.">HBL_READ_ONLY</a>,
<a name="l00137"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#aac34930556f611928ec9157c04bd1b0fa32a2f7b1c3430cc9c3f0f665934d0c4a">00137</a>                 HBL_NO_OVERWRITE
<a name="l00138"></a>00138                 
<a name="l00139"></a>00139             };
<a name="l00140"></a>00140         <span class="keyword">protected</span>:
<a name="l00141"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#aa8fecea9221ffacaae2f1fdea38558da">00141</a>             <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1HardwareBuffer.html#aa8fecea9221ffacaae2f1fdea38558da">mSizeInBytes</a>;
<a name="l00142"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#a2eb83f024781415a7fefb31f65a255c2">00142</a>             <a class="code" href="classOgre_1_1HardwareBuffer.html#ae51f5970d879af736e4cf53e1ec46630" title="Enums describing buffer usage; not mutually exclusive.">Usage</a> <a class="code" href="classOgre_1_1HardwareBuffer.html#a2eb83f024781415a7fefb31f65a255c2">mUsage</a>;
<a name="l00143"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#a25edb91791e48a7cc9ba2fb05f11bd33">00143</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1HardwareBuffer.html#a25edb91791e48a7cc9ba2fb05f11bd33">mIsLocked</a>;
<a name="l00144"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#a272cf9751affd73ea03930153357930b">00144</a>             <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1HardwareBuffer.html#a272cf9751affd73ea03930153357930b">mLockStart</a>;
<a name="l00145"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#ac96a7a04f4e29d8d00117a80d9a1c9a0">00145</a>             <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1HardwareBuffer.html#ac96a7a04f4e29d8d00117a80d9a1c9a0">mLockSize</a>;
<a name="l00146"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#af97b321278124803d13b700a46657ecb">00146</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1HardwareBuffer.html#af97b321278124803d13b700a46657ecb">mSystemMemory</a>;
<a name="l00147"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#a2caed02d4c9ad400d020ea8b0b24adf4">00147</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1HardwareBuffer.html#a2caed02d4c9ad400d020ea8b0b24adf4">mUseShadowBuffer</a>;
<a name="l00148"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#aa7af816828af5aceb84033a9e101efb6">00148</a>             <a class="code" href="classOgre_1_1HardwareBuffer.html" title="Abstract class defining common features of hardware buffers.">HardwareBuffer</a>* <a class="code" href="classOgre_1_1HardwareBuffer.html#aa7af816828af5aceb84033a9e101efb6">mShadowBuffer</a>;
<a name="l00149"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#a68127e87e132304c7655df554a82110c">00149</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1HardwareBuffer.html#a68127e87e132304c7655df554a82110c">mShadowUpdated</a>;
<a name="l00150"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#a47e53af2e87624c42ab934766bf65fca">00150</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1HardwareBuffer.html#a47e53af2e87624c42ab934766bf65fca">mSuppressHardwareUpdate</a>;
<a name="l00151"></a>00151             
<a name="l00153"></a>00153             <span class="keyword">virtual</span> <span class="keywordtype">void</span>* lockImpl(<span class="keywordtype">size_t</span> offset, <span class="keywordtype">size_t</span> length, <a class="code" href="classOgre_1_1HardwareBuffer.html#aac34930556f611928ec9157c04bd1b0f" title="Locking options.">LockOptions</a> options) = 0;
<a name="l00155"></a>00155             <span class="keyword">virtual</span> <span class="keywordtype">void</span> unlockImpl(<span class="keywordtype">void</span>) = 0;
<a name="l00156"></a>00156 
<a name="l00157"></a>00157     <span class="keyword">public</span>:
<a name="l00159"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#a43c79e8e2fa85a83f800214b3661bbbf">00159</a>             <a class="code" href="classOgre_1_1HardwareBuffer.html" title="Abstract class defining common features of hardware buffers.">HardwareBuffer</a>(<a class="code" href="classOgre_1_1HardwareBuffer.html#ae51f5970d879af736e4cf53e1ec46630" title="Enums describing buffer usage; not mutually exclusive.">Usage</a> usage, <span class="keywordtype">bool</span> systemMemory, <span class="keywordtype">bool</span> useShadowBuffer) 
<a name="l00160"></a>00160                 : mUsage(usage), mIsLocked(false), mSystemMemory(systemMemory), 
<a name="l00161"></a>00161                 mUseShadowBuffer(useShadowBuffer), mShadowBuffer(NULL), mShadowUpdated(false), 
<a name="l00162"></a>00162                 mSuppressHardwareUpdate(false) 
<a name="l00163"></a>00163             {
<a name="l00164"></a>00164                 <span class="comment">// If use shadow buffer, upgrade to WRITE_ONLY on hardware side</span>
<a name="l00165"></a>00165                 <span class="keywordflow">if</span> (useShadowBuffer &amp;&amp; usage == HBU_DYNAMIC)
<a name="l00166"></a>00166                 {
<a name="l00167"></a>00167                     mUsage = HBU_DYNAMIC_WRITE_ONLY;
<a name="l00168"></a>00168                 }
<a name="l00169"></a>00169                 <span class="keywordflow">else</span> <span class="keywordflow">if</span> (useShadowBuffer &amp;&amp; usage == HBU_STATIC)
<a name="l00170"></a>00170                 {
<a name="l00171"></a>00171                     mUsage = HBU_STATIC_WRITE_ONLY;
<a name="l00172"></a>00172                 }
<a name="l00173"></a>00173             }
<a name="l00174"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#a2514db557f1562eef2b7a70a1b2d8344">00174</a>             <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1HardwareBuffer.html#a2514db557f1562eef2b7a70a1b2d8344">~HardwareBuffer</a>() {}
<a name="l00181"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#ab1caebda1f7442706df97531c2d90aaf">00181</a>             <span class="keyword">virtual</span> <span class="keywordtype">void</span>* lock(<span class="keywordtype">size_t</span> offset, <span class="keywordtype">size_t</span> length, <a class="code" href="classOgre_1_1HardwareBuffer.html#aac34930556f611928ec9157c04bd1b0f" title="Locking options.">LockOptions</a> options)
<a name="l00182"></a>00182             {
<a name="l00183"></a>00183                 assert(!isLocked() &amp;&amp; <span class="stringliteral">&quot;Cannot lock this buffer, it is already locked!&quot;</span>);
<a name="l00184"></a>00184 
<a name="l00185"></a>00185                 <span class="keywordtype">void</span>* ret = NULL;
<a name="l00186"></a>00186                 <span class="keywordflow">if</span> ((length + offset) &gt; mSizeInBytes)
<a name="l00187"></a>00187                 {
<a name="l00188"></a>00188                     OGRE_EXCEPT(<a class="code" href="classOgre_1_1Exception.html#a9bdf9b8a0a83b95818d676848beaa29ba359c10b8abe9abf39f84550a903e4698">Exception::ERR_INVALIDPARAMS</a>,
<a name="l00189"></a>00189                         <span class="stringliteral">&quot;Lock request out of bounds.&quot;</span>,
<a name="l00190"></a>00190                         <span class="stringliteral">&quot;HardwareBuffer::lock&quot;</span>);
<a name="l00191"></a>00191                 }
<a name="l00192"></a>00192                 <span class="keywordflow">else</span> <span class="keywordflow">if</span> (mUseShadowBuffer)
<a name="l00193"></a>00193                 {
<a name="l00194"></a>00194                     <span class="keywordflow">if</span> (options != HBL_READ_ONLY)
<a name="l00195"></a>00195                     {
<a name="l00196"></a>00196                         <span class="comment">// we have to assume a read / write lock so we use the shadow buffer</span>
<a name="l00197"></a>00197                         <span class="comment">// and tag for sync on unlock()</span>
<a name="l00198"></a>00198                         mShadowUpdated = <span class="keyword">true</span>;
<a name="l00199"></a>00199                     }
<a name="l00200"></a>00200 
<a name="l00201"></a>00201                     ret = mShadowBuffer-&gt;lock(offset, length, options);
<a name="l00202"></a>00202                 }
<a name="l00203"></a>00203                 <span class="keywordflow">else</span>
<a name="l00204"></a>00204                 {
<a name="l00205"></a>00205                     <span class="comment">// Lock the real buffer if there is no shadow buffer </span>
<a name="l00206"></a>00206                     ret = lockImpl(offset, length, options);
<a name="l00207"></a>00207                     mIsLocked = <span class="keyword">true</span>;
<a name="l00208"></a>00208                 }
<a name="l00209"></a>00209                 mLockStart = offset;
<a name="l00210"></a>00210                 mLockSize = length;
<a name="l00211"></a>00211                 <span class="keywordflow">return</span> ret;
<a name="l00212"></a>00212             }
<a name="l00213"></a>00213 
<a name="l00218"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#a93b204642190e611bc226ea08d29160e">00218</a>             <span class="keywordtype">void</span>* lock(<a class="code" href="classOgre_1_1HardwareBuffer.html#aac34930556f611928ec9157c04bd1b0f" title="Locking options.">LockOptions</a> options)
<a name="l00219"></a>00219             {
<a name="l00220"></a>00220                 <span class="keywordflow">return</span> this-&gt;lock(0, mSizeInBytes, options);
<a name="l00221"></a>00221             }
<a name="l00234"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#a64ddd429ff2c8ac4f0cca5decb5c6757">00234</a>             <span class="keyword">virtual</span> <span class="keywordtype">void</span> unlock(<span class="keywordtype">void</span>)
<a name="l00235"></a>00235             {
<a name="l00236"></a>00236                 assert(isLocked() &amp;&amp; <span class="stringliteral">&quot;Cannot unlock this buffer, it is not locked!&quot;</span>);
<a name="l00237"></a>00237 
<a name="l00238"></a>00238                 <span class="comment">// If we used the shadow buffer this time...</span>
<a name="l00239"></a>00239                 <span class="keywordflow">if</span> (mUseShadowBuffer &amp;&amp; mShadowBuffer-&gt;isLocked())
<a name="l00240"></a>00240                 {
<a name="l00241"></a>00241                     mShadowBuffer-&gt;unlock();
<a name="l00242"></a>00242                     <span class="comment">// Potentially update the &#39;real&#39; buffer from the shadow buffer</span>
<a name="l00243"></a>00243                     _updateFromShadow();
<a name="l00244"></a>00244                 }
<a name="l00245"></a>00245                 <span class="keywordflow">else</span>
<a name="l00246"></a>00246                 {
<a name="l00247"></a>00247                     <span class="comment">// Otherwise, unlock the real one</span>
<a name="l00248"></a>00248                     unlockImpl();
<a name="l00249"></a>00249                     mIsLocked = <span class="keyword">false</span>;
<a name="l00250"></a>00250                 }
<a name="l00251"></a>00251 
<a name="l00252"></a>00252             }
<a name="l00253"></a>00253 
<a name="l00260"></a>00260             <span class="keyword">virtual</span> <span class="keywordtype">void</span> readData(<span class="keywordtype">size_t</span> offset, <span class="keywordtype">size_t</span> length, <span class="keywordtype">void</span>* pDest) = 0;
<a name="l00269"></a>00269             <span class="keyword">virtual</span> <span class="keywordtype">void</span> writeData(<span class="keywordtype">size_t</span> offset, <span class="keywordtype">size_t</span> length, <span class="keyword">const</span> <span class="keywordtype">void</span>* pSource,
<a name="l00270"></a>00270                     <span class="keywordtype">bool</span> discardWholeBuffer = <span class="keyword">false</span>) = 0;
<a name="l00271"></a>00271 
<a name="l00282"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#a721891f0c0bd391dd5848c8a585ba054">00282</a>             <span class="keyword">virtual</span> <span class="keywordtype">void</span> copyData(<a class="code" href="classOgre_1_1HardwareBuffer.html" title="Abstract class defining common features of hardware buffers.">HardwareBuffer</a>&amp; srcBuffer, <span class="keywordtype">size_t</span> srcOffset, 
<a name="l00283"></a>00283                 <span class="keywordtype">size_t</span> dstOffset, <span class="keywordtype">size_t</span> length, <span class="keywordtype">bool</span> discardWholeBuffer = <span class="keyword">false</span>)
<a name="l00284"></a>00284             {
<a name="l00285"></a>00285                 <span class="keyword">const</span> <span class="keywordtype">void</span> *srcData = srcBuffer.<a class="code" href="classOgre_1_1HardwareBuffer.html#ab1caebda1f7442706df97531c2d90aaf" title="Lock the buffer for (potentially) reading / writing.">lock</a>(
<a name="l00286"></a>00286                     srcOffset, length, HBL_READ_ONLY);
<a name="l00287"></a>00287                 this-&gt;writeData(dstOffset, length, srcData, discardWholeBuffer);
<a name="l00288"></a>00288                 srcBuffer.<a class="code" href="classOgre_1_1HardwareBuffer.html#a64ddd429ff2c8ac4f0cca5decb5c6757" title="Releases the lock on this buffer.">unlock</a>();
<a name="l00289"></a>00289             }
<a name="l00290"></a>00290 
<a name="l00296"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#a0bf3147b1f99a81dd84fb7b978c4686d">00296</a>             <span class="keyword">virtual</span> <span class="keywordtype">void</span> copyData(<a class="code" href="classOgre_1_1HardwareBuffer.html" title="Abstract class defining common features of hardware buffers.">HardwareBuffer</a>&amp; srcBuffer)
<a name="l00297"></a>00297             {
<a name="l00298"></a>00298                 <span class="keywordtype">size_t</span> sz = std::min(getSizeInBytes(), srcBuffer.<a class="code" href="classOgre_1_1HardwareBuffer.html#a1b1b5faf06139040824fd989d0b279f8" title="Returns the size of this buffer in bytes.">getSizeInBytes</a>()); 
<a name="l00299"></a>00299                 copyData(srcBuffer, 0, 0, sz, <span class="keyword">true</span>);
<a name="l00300"></a>00300             }
<a name="l00301"></a>00301             
<a name="l00303"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#a344c52f2214eaff097d5fbc390e7684b">00303</a>             <span class="keyword">virtual</span> <span class="keywordtype">void</span> _updateFromShadow(<span class="keywordtype">void</span>)
<a name="l00304"></a>00304             {
<a name="l00305"></a>00305                 <span class="keywordflow">if</span> (mUseShadowBuffer &amp;&amp; mShadowUpdated &amp;&amp; !mSuppressHardwareUpdate)
<a name="l00306"></a>00306                 {
<a name="l00307"></a>00307                     <span class="comment">// Do this manually to avoid locking problems</span>
<a name="l00308"></a>00308                     <span class="keyword">const</span> <span class="keywordtype">void</span> *srcData = mShadowBuffer-&gt;lockImpl(
<a name="l00309"></a>00309                         mLockStart, mLockSize, HBL_READ_ONLY);
<a name="l00310"></a>00310                     <span class="comment">// Lock with discard if the whole buffer was locked, otherwise normal</span>
<a name="l00311"></a>00311                     <a class="code" href="classOgre_1_1HardwareBuffer.html#aac34930556f611928ec9157c04bd1b0f" title="Locking options.">LockOptions</a> lockOpt;
<a name="l00312"></a>00312                     <span class="keywordflow">if</span> (mLockStart == 0 &amp;&amp; mLockSize == mSizeInBytes)
<a name="l00313"></a>00313                         lockOpt = HBL_DISCARD;
<a name="l00314"></a>00314                     <span class="keywordflow">else</span>
<a name="l00315"></a>00315                         lockOpt = HBL_NORMAL;
<a name="l00316"></a>00316                     
<a name="l00317"></a>00317                     <span class="keywordtype">void</span> *destData = this-&gt;lockImpl(
<a name="l00318"></a>00318                         mLockStart, mLockSize, lockOpt);
<a name="l00319"></a>00319                     <span class="comment">// Copy shadow to real</span>
<a name="l00320"></a>00320                     memcpy(destData, srcData, mLockSize);
<a name="l00321"></a>00321                     this-&gt;unlockImpl();
<a name="l00322"></a>00322                     mShadowBuffer-&gt;unlockImpl();
<a name="l00323"></a>00323                     mShadowUpdated = <span class="keyword">false</span>;
<a name="l00324"></a>00324                 }
<a name="l00325"></a>00325             }
<a name="l00326"></a>00326 
<a name="l00328"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#a1b1b5faf06139040824fd989d0b279f8">00328</a>             <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1HardwareBuffer.html#a1b1b5faf06139040824fd989d0b279f8" title="Returns the size of this buffer in bytes.">getSizeInBytes</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mSizeInBytes; }
<a name="l00330"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#a0e00770f5e9395e41b6520be8421a6c8">00330</a>             <a class="code" href="classOgre_1_1HardwareBuffer.html#ae51f5970d879af736e4cf53e1ec46630" title="Enums describing buffer usage; not mutually exclusive.">Usage</a> <a class="code" href="classOgre_1_1HardwareBuffer.html#a0e00770f5e9395e41b6520be8421a6c8" title="Returns the Usage flags with which this buffer was created.">getUsage</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mUsage; }
<a name="l00332"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#a61086322fba08abadf4fe6734a7c70f7">00332</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1HardwareBuffer.html#a61086322fba08abadf4fe6734a7c70f7" title="Returns whether this buffer is held in system memory.">isSystemMemory</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mSystemMemory; }
<a name="l00334"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#ad523887cfaa6abe48dd494a3ea06805a">00334</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1HardwareBuffer.html#ad523887cfaa6abe48dd494a3ea06805a" title="Returns whether this buffer has a system memory shadow for quicker reading.">hasShadowBuffer</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mUseShadowBuffer; }
<a name="l00336"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#a3d5a62cbd76fc2ecd4e1a540bac5f9bc">00336</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1HardwareBuffer.html#a3d5a62cbd76fc2ecd4e1a540bac5f9bc" title="Returns whether or not this buffer is currently locked.">isLocked</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ 
<a name="l00337"></a>00337                 <span class="keywordflow">return</span> mIsLocked || (mUseShadowBuffer &amp;&amp; mShadowBuffer-&gt;isLocked()); 
<a name="l00338"></a>00338             }
<a name="l00340"></a><a class="code" href="classOgre_1_1HardwareBuffer.html#a688e1be4a913099ce5e06172771e2d45">00340</a>             <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1HardwareBuffer.html#a688e1be4a913099ce5e06172771e2d45" title="Pass true to suppress hardware upload of shadow buffer changes.">suppressHardwareUpdate</a>(<span class="keywordtype">bool</span> suppress) {
<a name="l00341"></a>00341                 mSuppressHardwareUpdate = suppress;
<a name="l00342"></a>00342                 <span class="keywordflow">if</span> (!suppress)
<a name="l00343"></a>00343                     _updateFromShadow();
<a name="l00344"></a>00344             }
<a name="l00345"></a>00345 
<a name="l00346"></a>00346 
<a name="l00347"></a>00347 
<a name="l00348"></a>00348 
<a name="l00349"></a>00349             
<a name="l00350"></a>00350     };
<a name="l00353"></a>00353 }
<a name="l00354"></a>00354 <span class="preprocessor">#endif</span>
<a name="l00355"></a>00355 <span class="preprocessor"></span>
<a name="l00356"></a>00356 
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
